#ifndef MAIN_H_
#define MAIN_H_

#define INITIAL_HIGHT 675
#define INITIAL_WIDTH 900
#define MCA_SIZE 32768

#include <TGFrame.h>
#include <TGMenu.h>
#include <TGApplication.h>
#include <TGTab.h>
#include <TGButton.h>
#include <TGNumberEntry.h>
#include <TGLabel.h>
#include <TGTextEntry.h>
#include <TRootEmbeddedCanvas.h>
#include <TH1S.h>
#include <TSystem.h>
#include <TStyle.h>
#include <TGFileDialog.h>
#include <TCanvas.h>
#include <iostream>
#include <fstream>
#include <TGTextEdit.h>
#include <TThread.h>
#include <TTimer.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include "TGStatusBar.h"
#include "hw.h"
#include "TVirtualPad.h"
#include "TObject.h"


using namespace std;

typedef struct {
   Bool_t    fRun;
   HistWin *fhistwin;
   TThread  *fThread;
   TCanvas  *fCanvas;
   TH1F     *fHisto;
} ThreadArgs_t;

enum Commands //commands for the menu bar popups

{
	START_BUTTON,
	STOP_BUTTON,CLOSE_BUTTON,HW_CLOSE,
	SMCASPEC_BUTTON,
	HCHAN_NO,
	REFMCAFROM_MODULE,
	HISTRUNNO,
	HFOPICB
};

class Main : public TGMainFrame{
public:
	Main();
	Main(const TGWindow * p);
	virtual ~Main(); 
	void UpdateStatus();
	void* Thread1(void* arg = 0 );
	Bool_t startbpressed , stopbpressed , tstopbpressed ;
// tstopbpressed // variable used in thread - thread stop button pressed
	Bool_t timeover;
	Bool_t brun_finished;   // kTRUE if run is finished
// brun_finished - one run with the current run_no is finished i.e. one run_time is over
// (when loop is  ticked yes or no and run_time is over ) or when stop button is pressed

	Bool_t bfinalrun_finished;   // kTRUE if run is finished , loop is ticked yes and stop button is pressed  OR
					// loop is ticked no and run_time is over or stop button is pressed
	TTimer *timer;
	unsigned int Eventno003; 

protected :


private:

   TThread             *mTh;      

   ThreadArgs_t         fThreadArgs;

	//variables
	TGTextEntry *StateMsgFold1;

	Pixel_t color;
//////////////////////////////////////////////////
	HistWin *histwin;

	int xmin, xmax, ymin, ymax;
	TGNumberEntry *numericMod, *numericCh;
	//, *numericModMCA, *numericChMCA;

	unsigned short *trace, *filter_trace;

	int NumWords ;
	float *trace_float;

	bool hpx_once_wave;
	unsigned short modNumber, chanNumber;
	bool wave_once;
	//methods
	virtual Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t);//process message queue
	void CloseWindow(); //close main window

	void MakePanel(const TGWindow * q);   

	int range, separation;///filter parameters
	float fraction; ///filter parameters
	unsigned long mca[MCA_SIZE];

	int NUMBERofTRACES;
	TObject *selected;
	int parts[6];

// composite frame
   TGCompositeFrame *fMainFrame1310;

   ULong_t ucolor,color1;          // will reflect user color changes

// vertical frame
   TGVerticalFrame *fVerticalFrame560;

   TGFont *ufont;         // will reflect user font changes
   TGGC   *uGC;           // will reflect user GC changes

TGLabel *fLabel1628;
TGNumberEntry *fNumberEntry777;
TGTextButton *fTextButton1633;
TGTextButton *fTextButton1634;
TGTextButton *fTextButton1637; // CLOSE_BUTTON
TGTextButton *fTextButton1635;
TGCheckButton *fCheckButton1636;
TGLabel *fLabel1637;
TGNumberEntry *fNumberEntry1051;


Bool_t Autoincrmntrun_no;   // FALSE - do not increment ,
			    // TRUE - auto increment run number

	//////////////////////timing stuff////////////////////////////
	struct timeval tim;
	double t1 , t2 , trun , trunset , truntimeout ; 
	////////////////////////////////////////

//***********************************************

ClassDef(Main,0);
	
};

#endif /*MAIN_H_*/
